%{

/*
 * lexer.l file
 * To generate the lexical analyzer run: "flex lexer.l"
 */

#include <stdio.h>
#include "parser.function_annotation_parser.tab.h"

%}

%option noyywrap

FUNCTION_NAME       [a-zA-Z][a-zA-Z0-9_]*
NUMBER              [0-9]+

RISC                "RISC"
TIME                "time"

CONFLICT_FREE       "conflict-free"
NOT_CONFLICT_FREE   "not-conflict-free"

EVENT               "event"
SC_ZERO_TIME        "sc-zero-time"

NO_WAIT             "no-wait"
UNCONDITIONAL_WAIT  "unconditional-wait"
CONDITIONAL_WAIT    "conditional-wait"
LOOPED_WAIT         "looped-wait"
WORST_WAIT          "worst-wait"

SC_FS               "SC_FS"
SC_PS               "SC_PS"
SC_NS               "SC_NS"
SC_US               "SC_US"
SC_MS               "SC_MS"
SC_SEC              "SC_SEC"

LPAREN              [(]
RPAREN              [)]
COMMA               [,]
WS                  [\t\n\r ]+

%%

{RISC}               { return T_RISC; }
{COMMA}              { return T_COMMA; }
{TIME}               { return T_TIME; }

{CONFLICT_FREE}      { return T_CONFLICT_FREE; }
{NOT_CONFLICT_FREE}  { return T_NOT_CONFLICT_FREE; }

{NO_WAIT}            { return T_NO_WAIT; }
{UNCONDITIONAL_WAIT} { return T_UNCONDITIONAL_WAIT; }
{CONDITIONAL_WAIT}   { return T_CONDITIONAL_WAIT; }
{LOOPED_WAIT}        { return T_LOOPED_WAIT; }
{WORST_WAIT}         { return T_WORST_WAIT; }

{EVENT}              { return T_EVENT; }
{SC_ZERO_TIME}       { return T_SC_ZERO_TIME; }

{SC_FS}              { return T_SC_FS; }
{SC_PS}              { return T_SC_PS; }
{SC_NS}              { return T_SC_NS; }
{SC_US}              { return T_SC_US; }
{SC_MS}              { return T_SC_MS; }
{SC_SEC}             { return T_SC_SEC; }

{FUNCTION_NAME}      {
                       char *function_annotation_parsertext_copy = (char*)malloc(sizeof(char) * (strlen(function_annotation_parsertext) + 1));
                       strcpy(function_annotation_parsertext_copy, function_annotation_parsertext);
                       function_annotation_parserlval.function_name_ = function_annotation_parsertext_copy;

                       return T_FUNCTION_NAME;
                     }

{NUMBER}             {
                       function_annotation_parserlval.number_ = atoi(function_annotation_parsertext);
                       return T_NUMBER;
                     }

{LPAREN}             { return T_LPAREN; }
{RPAREN}             { return T_RPAREN; }
{WS}                 { }

%%

void function_annotation_parsererror(char const *s)
{
  function_annotation = NULL;
  return;
}

