#include "systemc.h"

class Interface: virtual public sc_interface {
public:
  virtual void func() = 0;
};

class SubChannelSender1: public sc_module {

  SC_HAS_PROCESS(SubChannelSender1);

public:
  int &ref_;
  sc_event &event_;

  SubChannelSender1(sc_module_name mn, sc_event &event, int &ref):
    sc_module(mn),
    ref_(ref),
    event_(event)
  {
    SC_THREAD(thread1);

    SC_THREAD(thread2);
  }

  void thread1()
  {
    int NewForRead = ref_;
  }

  void thread2()
  {
    event_.notify(SC_ZERO_TIME);
  }
};

class SubModuleReceiver1: public sc_module {

  SC_HAS_PROCESS(SubModuleReceiver1);

public:
  int &ref_;
  sc_event &event_;

  SubModuleReceiver1(sc_module_name mn, sc_event &event, int &ref):
    sc_module(mn),
    event_(event),
    ref_(ref)
  {
    SC_THREAD(thread1);

    SC_THREAD(thread2);
  }

  void thread1()
  {
    ref_ = 5;
  }

  void thread2()
  {
    wait(event_);
  }
};

class TopModule1: public sc_module, public virtual Interface {

public:
  int var_0;
  int var_1;
  int var_2;
  int var_3;

  sc_event event_0;
  sc_event event_1;
  sc_event event_2;
  sc_event event_3;

  SubChannelSender1 *sub_channel[4];
  SubModuleReceiver1 *sub_module[4];

  TopModule1(sc_module_name mn):
    sc_module(mn)
  {
    sub_channel[0] = new SubChannelSender1("SubChannelSender10", event_0, var_0);
    sub_channel[1] = new SubChannelSender1("SubChannelSender11", event_1, var_1);
    sub_channel[2] = new SubChannelSender1("SubChannelSender12", event_2, var_2);
    sub_channel[3] = new SubChannelSender1("SubChannelSender13", event_3, var_3);

    sub_module[0] = new SubModuleReceiver1("SubModuleReceiver10", event_0, var_0);
    sub_module[1] = new SubModuleReceiver1("SubModuleReceiver11", event_1, var_1);
    sub_module[2] = new SubModuleReceiver1("SubModuleReceiver12", event_2, var_2);
    sub_module[3] = new SubModuleReceiver1("SubModuleReceiver13", event_3, var_3);
  }

  virtual void func()
  { }
};

class TopChannel2: public sc_channel, public virtual Interface {

public:
  int var_0;
  int var_1;
  int var_2;
  int var_3;

  sc_event event_0;
  sc_event event_1;
  sc_event event_2;
  sc_event event_3;

  SubChannelSender1 *sub_channel[4];
  SubModuleReceiver1 *sub_module[4];

  TopChannel2(sc_module_name mn):
    sc_channel(mn)
  {
    sub_channel[0] = new SubChannelSender1("SubChannelSender10", event_0, var_0);
    sub_channel[1] = new SubChannelSender1("SubChannelSender11", event_1, var_1);
    sub_channel[2] = new SubChannelSender1("SubChannelSender12", event_2, var_2);
    sub_channel[3] = new SubChannelSender1("SubChannelSender13", event_3, var_3);

    sub_module[0] = new SubModuleReceiver1("SubModuleReceiver10", event_0, var_0);
    sub_module[1] = new SubModuleReceiver1("SubModuleReceiver11", event_1, var_1);
    sub_module[2] = new SubModuleReceiver1("SubModuleReceiver12", event_2, var_2);
    sub_module[3] = new SubModuleReceiver1("SubModuleReceiver13", event_3, var_3);
  }

  virtual void func()
  { }
};



class TopChannelTestChannel: public sc_channel, public virtual Interface {

public:

  TopModule1 tm1;
  TopChannel2 tc1;

  TopChannelTestChannel(sc_module_name mn):
    sc_channel(mn),
    tm1("tm1"),
    tc1("cm1")
  { }

  virtual void func()
  { }
};

int sc_main(int argc, char **argv)
{
  TopChannelTestChannel tct("TopChannelTest");

  sc_start();
  return 0;
}
